package com.stryker.cmf.accountrolebean;

import java.util.List;
import java.util.logging.Level;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 * Facade for entity Users.
 * 
 * @see com.stryker.cmf.accountrolebean.Users
 * @author MyEclipse Persistence Tools
 */
@Stateless
public class UsersFacade implements UsersFacadeLocal {
	// property constants
	public static final String PASSWORD = "password";

	@PersistenceContext
	private EntityManager entityManager;

	public void save(Users transientInstance) {
		EntityManagerHelper.log("saving Users instance", Level.INFO, null);
		try {
			entityManager.persist(transientInstance);
			EntityManagerHelper.log("save successful", Level.INFO, null);
		} catch (RuntimeException re) {
			EntityManagerHelper.log("save failed", Level.SEVERE, re);
			throw re;
		}
	}

	public void delete(Users persistentInstance) {
		EntityManagerHelper.log("deleting Users instance", Level.INFO, null);
		try {
			entityManager.remove(persistentInstance);
			EntityManagerHelper.log("delete successful", Level.INFO, null);
		} catch (RuntimeException re) {
			EntityManagerHelper.log("delete failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Users update(Users detachedInstance) {
		EntityManagerHelper.log("updating Users instance", Level.INFO, null);
		try {
			Users result = entityManager.merge(detachedInstance);
			EntityManagerHelper.log("update successful", Level.INFO, null);
			return result;
		} catch (RuntimeException re) {
			EntityManagerHelper.log("update failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Users findById(String id) {
		EntityManagerHelper.log("finding Users instance with id: " + id,
				Level.INFO, null);
		try {
			Users instance = entityManager.find(Users.class, id);
			return instance;
		} catch (RuntimeException re) {
			EntityManagerHelper.log("find failed", Level.SEVERE, re);
			throw re;
		}
	}

	@SuppressWarnings("unchecked")
	public List<Users> findByProperty(String propertyName, Object value) {
		EntityManagerHelper.log("finding Users instance with property: "
				+ propertyName + ", value: " + value, Level.INFO, null);
		try {
			String queryString = "select model from Users model where model."
					+ propertyName + "= :propertyValue";
			return entityManager.createQuery(queryString).setParameter(
					"propertyValue", value).getResultList();
		} catch (RuntimeException re) {
			EntityManagerHelper.log("find by property name failed",
					Level.SEVERE, re);
			throw re;
		}
	}

	public List<Users> findByPassword(Object password) {
		return findByProperty(PASSWORD, password);
	}

	@SuppressWarnings("unchecked")
	public List<Users> findAll() {
		EntityManagerHelper
				.log("finding all Users instances", Level.INFO, null);
		try {
			String queryString = "select model from Users model";
			return entityManager.createQuery(queryString).getResultList();
		} catch (RuntimeException re) {
			EntityManagerHelper.log("find all failed", Level.SEVERE, re);
			throw re;
		}
	}
}